/*
**	Copyright  1994 Novell, Inc.  All rights reserved.
**
**	Permission is granted to the recipient of this work ("you") to use,
**	reproduce and distribute Novell's original publication of the work free
**	of charge provided that you reproduce the work in its entirety and
**	include all Novell copyright notices as they originally appear.
**
**	Novell grants you permission to modify and distribute copies of this
**	work including any portion of this work (a "modified work") provided
**	that you include prominent notification of such modification along with
**	the date of modification on a modified work; distribute or publish a
**	modified work to third parties under the same conditions and granting
**	the same rights as are extended to you by Novell under this under
**	permission notice; and provided that you include a copy of Novell's
**	original publication of the work along with any copy of a modified
**	work.
**
**	NOVELL MAKES NO WARRANTY, REPRESENTATION OR PROMISE THAT THIS WORK OR A
**	MODIFIED WORK WILL SATISFY YOUR REQUIREMENTS OR THAT THIS WORK OR A
**	MODIFIED WORK IS WITHOUT DEFECT OR ERROR.  NOVELL DISCLAIMS AND
**	EXCLUDES ANY AND ALL IMPLIED WARRANTIES OF MERCHANTABILITY, TITLE OR
**	FITNESS FOR A PARTICULAR PURPOSE.
**
**	IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW WILL NOVELL OR ANY OTHER
**	PARTY BE LIABLE FOR DAMAGES INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL,
**	CONSEQUENTIAL, INDIRECT OR PUNATIVE DAMAGES ARISING OUT OF THE USE OF
**	OR INABLITITY TO USE THE WORK OR A MODIFIED WORK.
**
**	DSCONNBU.H - October 1994
**
**	Declaration of the DSConnBuffer class.
**
**	Author: John Buckle, Asia Pacific Support Centre, Novell Australia
**	==================================================================
**	9 Jan 1995           First release              John Buckle
*/

# ifndef dsCONNBU_H
# define dsCONNBU_H

# include "dsdefs.h"
# include "dsbuffer.h"
# include "dsconn.h"

/*
** Class DSConnBuffer
**
**	Combine the functionality of the DSBuffer and DSConn classes.
*/

class _DSCLASSDEC DSConnBuffer : public DSBuffer, public DSConn
{
protected:

public:
			DSConnBuffer(
				 NWPSTR context    = 0,
				 DWORD  flags      = DSCPP_CONTEXT_FLAGS,
				 WORD   inputSize  = DEFAULT_MESSAGE_LEN,
				 WORD   outputSize = DEFAULT_MESSAGE_LEN,
				 WORD   filterSize = DEFAULT_MESSAGE_LEN)
			: DSBuffer(context,flags,inputSize,outputSize,filterSize)
				{ Context = dContext ; }
			DSConnBuffer(DSConnBuffer &) ;
	virtual	      ~ DSConnBuffer() 			{ ; }
	void		operator=(DSConnBuffer &) ;
			operator NWCONN_HANDLE()	{ return ConnHandle ; }
			operator NWDSContextHandle()	{ return dContext ; }

	NWDSCCODE	status() 	{ return DSBuffer::Status ? DSBuffer::Status : DSConn::Status ; }
	NWDSCCODE	reset () 	{ return DSBuffer::Status = DSConn::Status = 0 ; }
} ;

# endif dsCONNBU_H
